### Function

# GLib locale_to_utf8

#### Declaration [src]

    gchar*
    g_locale_to_utf8 (
      const gchar* opsysstring,
      gssize len,
      gsize* bytes_read,
      gsize* bytes_written,
      GError** error
    )

#### Description [src]

Converts a string which is in the encoding used for strings by the C runtime (usually the same as that used by the operating system) in the current locale into a UTF-8 string.

If the source encoding is not UTF-8 and the conversion output contains a nul character, the error `G_CONVERT_ERROR_EMBEDDED_NUL` is set and the function returns `NULL`. If the source encoding is UTF-8, an embedded nul character is treated with the `G_CONVERT_ERROR_ILLEGAL_SEQUENCE` error for backward compatibility with earlier versions of this library. Use `g_convert()` to produce output that may contain embedded nul characters.

#### Parameters

`opsysstring`

  Type: An array of `guint8`

  A string in the encoding of the current locale. On Windows this means the system codepage.

  The length of the array is specified in the `len` argument.
  The data is owned by the caller of the function.

`len`

  Type: `gssize`

  The length of the string, or -1 if the string is nul-terminated (Note that some encodings may allow nul bytes to occur inside strings. In that case, using -1 for the `len` parameter is unsafe).

`bytes_read`

  Type: `gsize*`

  Location to store the number of bytes in the input string that were successfully converted, or `NULL`. Even if the conversion was successful, this may be less than `len` if there were partial characters at the end of the input. If the error `G_CONVERT_ERROR_ILLEGAL_SEQUENCE` occurs, the value stored will be the byte offset after the last valid input sequence.

  The argument will be set by the function.
  The argument can be `NULL`.

`bytes_written`

  Type: `gsize*`

  The number of bytes stored in the output buffer (not including the terminating nul).

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

The converted string, or `NULL` on an error.

The caller of the function takes ownership of the data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.